﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ParticleScript : MonoBehaviour
{
    Vector3 pOld;
    float R;
    public float mass = 1;
    public bool fixedInPlace = false;
    Vector3 startingPosition;

    // Start is called before the first frame update
    void Start()
    {
        pOld = transform.position;
        startingPosition = transform.position;
        R = transform.localScale.x * 0.5f;
    }

    void doOneStep(){
        Vector3 pNow = transform.position;
        float dt = Time.fixedDeltaTime;

        Vector3 accG = Vector3.down * 19.8f ;
        Vector3 a = accG /* + ... */;

        const float DAMP = 1 - 0.05f;
        pNow = (1+DAMP)*pNow - DAMP*pOld + a * dt*dt;

        pNow.y = Mathf.Max( pNow.y , R );
        pNow.x = Mathf.Clamp( pNow.x , -30+R , +30-R );
        pNow.z = Mathf.Clamp( pNow.z , -30+R , +30-R );

        if (fixedInPlace) pNow = startingPosition;

        pOld = transform.position;
        transform.position = pNow;

    }

    void FixedUpdate()
    {
        doOneStep();    
    }
}
